=== modified file 'NEWS'
--- NEWS	2007-05-10 05:55:01 +0000
+++ NEWS	2007-05-23 08:54:14 +0000
@@ -8,6 +8,9 @@
       that we can pass in the Transport that we already have.
       (John Arbash Meinel, #75721)
 
+    * Let TestUIFactoy encode the password prompt with its own stdout.
+      (Vincent Ladeuil, #110204)
+
 
 bzr 0.16  2007-05-07
   

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2007-05-16 18:30:55 +0000
+++ bzrlib/tests/__init__.py	2007-05-23 08:54:14 +0000
@@ -721,7 +721,7 @@
     def get_non_echoed_password(self, prompt):
         """Get password from stdin without trying to handle the echo mode"""
         if prompt:
-            self.stdout.write(prompt)
+            self.stdout.write(prompt.encode(self.stdout.encoding, 'replace'))
         password = self.stdin.readline()
         if not password:
             raise EOFError

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2007-03-23 01:41:37 +0000
+++ bzrlib/ui/__init__.py	2007-04-26 20:52:43 +0000
@@ -35,6 +35,7 @@
 import getpass
 
 from bzrlib import (
+    osutils,
     progress,
     trace,
     )
@@ -111,7 +112,7 @@
             current_format_name,
             basedir)
 
-            
+
 class CLIUIFactory(UIFactory):
     """Common behaviour for command line UI factories."""
 
@@ -131,7 +132,8 @@
                 return False
 
     def get_non_echoed_password(self, prompt):
-        return getpass.getpass(prompt)
+        encoding = osutils.get_terminal_encoding()
+        return getpass.getpass(prompt.encode(encoding, 'replace'))
 
     def get_password(self, prompt='', **kwargs):
         """Prompt the user for a password.
@@ -144,7 +146,7 @@
                  canceled the request.
         """
         prompt += ': '
-        prompt = (prompt % kwargs).encode(sys.stdout.encoding, 'replace')
+        prompt = (prompt % kwargs)
         # There's currently no way to say 'i decline to enter a password'
         # as opposed to 'my password is empty' -- does it matter?
         return self.get_non_echoed_password(prompt)

